<?

/*----------------------------------------------------------------------------*/
/* Ce programme appartient au projet eflore, port par l'association          */
/* Tela Botanica (http://www.tela-botanica.org). Il a pour but d'tablir les  */
/* structures d'informations necessaires  l'etablissement d'une flore        */
/* electronique et de dvelopper les outils informatiques les exploitant.     */ 
/*                                                                            */
/* Copyright (C) 2001 tela-botanica. This program is free software;           */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* either version 2 of the License, or (at your option) any later version.    */
/* This program is distributed in the hope that it will be useful, but        */
/* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details. You should have received a copy of the GNU General       */
/* Public License along with this program; if not, write to the               */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    */
/*----------------------------------------------------------------------------*/

 /* Cette classe permet de dfinir les mthodes d'accs  la table EFLORE_CLASSIFICATIONS */
  /* aussi bien en lecture qu'en criture */

class ClassificationAccess{

var $monCurseur;   /*unCurseur sur une requte SQL*/

function ClassificationAccess()
{
}



function readRow($row,$dblink,$db)

	/* Cette mthode permet d'affecter les donnes d'une ligne ramene par une curseur */
	/*  un object de type Classification.  */
	/* $row : la ligne contenant les donnes */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Resultat: un nouvel object Classification contenant les donnes de la ligne */  

{
	$maClassification = new Classification();
	$maClassification->numClass = $row[EF_C_NUM_CLASS];
	$maClassification->description = $row[EF_C_DESCRIPTION];
	$maClassification->premierTaxon = NomTaxonAccess::getNomTaxon($row[EF_C_NUM_NOM],$dblink,$db);
		
	return($maClassification);
}


function getClassification($numclass,$dblink,$db)

	/* Cette mthode permet de lire dans la base le taxon ayant un certain numero de classification  */
	/* $numclass : le numro identifiant la classification recherche        */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Rsultat : un nouvel object Nomtaxon contenant les donnes de la ligne */   
{
	$sql="select * ";
	$sql.="from ".EF_C." ";
	$sql.="where ".EF_C_NUM_CLASS."= $numclass ";

	$maClassification;

	If ($res=mysql($db,$sql,$dblink))
	{
		if (mysql_num_rows($res)==1)
		{	$row = mysql_fetch_array($res,MYSQL_ASSOC);
			$maClassification = ClassificationAccess::readRow($row,$dblink,$db);					
		}
		mysql_free_result($res);
	}
	
	
	return($maClassification);

}


function openClassificationCursor($dblink,$db)
	/* Cette mthode ouvre un curseur sur l'ensemble des classification existantes  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Rsultat : aucun */   

{
	$sql="select * ";
	$sql.="from ".EF_C." ";
	$sql.="order by ".EF_C_NUM_CLASS." ";


	$this->monCurseur=mysql($db,$sql,$dblink);
	
}

function closeClassificationCursor()
	/* Cette mthode ferme le curseur  */
	/* Rsultat : aucun */   
{
	mysql_free_result($this->monCurseur);
}

function nextClassification($dblink,$db)
	/* Cette mthode permet de lire une  une les lignes ramenes par le curseur  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Rsultat : un object Classification ou NULL quand il n'y a plus de lignes  lire */   
{
	$maClassification;
	
	if (mysql_num_rows($this->monCurseur)>0)
	{	
		if($row = mysql_fetch_array($this->monCurseur,MYSQL_ASSOC))
		{
			$maClassification = ClassificationAccess::readRow($row,$dblink,$db);
		}
		else
		{	$maClassification =NULL;	}					
	}
	
	return($maClassification);
}



}
?>