<?

/*----------------------------------------------------------------------------*/
/* Ce programme appartient au projet eflore, port par l'association          */
/* Tela Botanica (http://www.tela-botanica.org). Il a pour but d'tablir les  */
/* structures d'informations necessaires  l'etablissement d'une flore        */
/* electronique et de dvelopper les outils informatiques les exploitant.     */ 
/*                                                                            */
/* Copyright (C) 2001 tela-botanica. This program is free software;           */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* either version 2 of the License, or (at your option) any later version.    */
/* This program is distributed in the hope that it will be useful, but        */
/* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details. You should have received a copy of the GNU General       */
/* Public License along with this program; if not, write to the               */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    */
/*----------------------------------------------------------------------------*/

 /* Cette classe permet de dfinir les mthodes d'accs  la table EFLORE_CLASSIFICATION_TAXONS */
  /* aussi bien en lecture qu'en criture */

class ClassificationTaxonsAccess{

var $monCurseur; /*unCurseur sur une requte SQL*/

function ClassificationtaxonsAccess()
{
}



function readRow($row)
	/* Cette mthode permet d'affecter les donnes d'une ligne ramene par une curseur */
	/*  un object de type NomTaxonClassif.  */
	/* $row : la ligne contenant les donnes */
	/* Resultat: un nouvel object NomTaxonClassif contenant les donnes de la ligne */

{
	$unTaxon = new NomTaxonClassif(NomTaxonAccess::readRow($row));
	/*NomTaxonAccess::readRow($row,&$unTaxon);*/
	$unTaxon->numeroTaxonomiqueSup = $row[EF_TCT_NUM_TAXO_SUP];
	$unTaxon->numeroNomenclaturalSup = $row[EF_TCT_NUM_NOM_SUP];
	$unTaxon->numeroTaxonomiqueInf = $row[EF_TCT_NUM_TAXO_INF];
	$unTaxon->numeroNomenclaturalInf = $row[EF_TCT_NUM_NOM_INF];
	$unTaxon->classificationGlobale = $row[EF_TCT_CLASSIFICATION_GLOBALE];
	return($unTaxon);


}

function getNomTaxonClassif($numclass,$numNomenclatural,$dblink,$db,$unNomTaxon)

	/* Cette mthode permet de lire dans la base le taxon ayant un certain numero nomenclatural  */
	/* elle est utilise pour obtenir les informations du premier taxon lu dans la classification */
	/* $numclass : le numro identifiant la classification recherche        */
	/* $numTaxonomique : le numro taxonomique du taxon                      */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* $unNomTaxon : un nouvel object NomTaxonClassif contenant les donnes de la ligne */  

{
	$sql="select * ";
	$sql.="from ".EF_TCT." c, ".EF_TNT." n ";
	$sql.="where c.".EF_TCT_NUM_CLASS." = $numclass ";
	/*$sql.="and c.".EF_TCT_CLASSIFICATION_GLOBALE." like '$classification%' ";*/
	$sql.="and n.".EF_TNT_NUM_NOMENCLATURAL." = c.".EF_TCT_NUM_NOM_INF."  ";
	$sql.="and c.".EF_TCT_NUM_NOM_INF." = $numNomenclatural";


	If ($res=mysql($db,$sql,$dblink))
	{
		if (mysql_num_rows($res)==1)
		{	$row = mysql_fetch_array($res,MYSQL_ASSOC);
			$unNomTaxon=ClassificationtaxonsAccess::readRow($row);		
		}
	}
	

	

}


function openClassificationTaxonCursor($dblink,$db,$numclass,$classification,$rangtaxo,$profondeur)
	/* Cette mthode ouvre un curseur sur l'ensemble des classification existantes  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* $numclass : le numro identifiant la classification recherche        */
	/* $classification : identifie l'endroit de la classificatio ou l'on dbute la lecture        */
	/* $rangtaxo : indique le rang taxonomique  ne pas dpasser        */
	/* $profondeur : indique la profondeur relatve  ne pas dpasser    */
	/* Rsultat : aucun */   
{
	$sql="select * ";
	$sql.="from ".EF_TCT." c, ".EF_TNT." n ";
	$sql.="where c.".EF_TCT_NUM_CLASS." = $numclass ";
	$sql.="and c.".EF_TCT_CLASSIFICATION_GLOBALE." like '".trim($classification)."%' ";
	$sql.="and n.".EF_TNT_NUM_NOMENCLATURAL." = c.".EF_TCT_NUM_NOM_INF."  ";
	$sql.="and n.".EF_TNT_RANG_TAXONOMIQUE." < $rangtaxo ";
	$sql.="and LENGTH(c.".EF_TCT_CLASSIFICATION_GLOBALE.")/10 <= $profondeur ";
	$sql.="order by ".EF_TCT_CLASSIFICATION_GLOBALE." ";


	$this->monCurseur=mysql($db,$sql,$dblink);

}


function closeClassificationTaxonCursor()
	/* Cette mthode ferme le curseur  */
	/* Rsultat : aucun */  

{
	mysql_free_result($this->monCurseur);
}

function nextClassificationTaxon($dblink,$db)

	/* Cette mthode permet de lire une  une les lignes ramenes par le curseur  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Rsultat : un object NomTaxonClassif ou NULL quand il n'y a plus de lignes  lire */   
{
	$monTaxonClassif;
	
	if (mysql_num_rows($this->monCurseur)>0)
	{	
		if($row = mysql_fetch_array($this->monCurseur,MYSQL_ASSOC))
		{
			$monTaxonClassif = ClassificationTaxonsAccess::readRow($row);
		}
		else
		{	$monTaxonClassif =NULL;	}					
	}
	
	return($monTaxonClassif);
}



}
?>