<?

/*----------------------------------------------------------------------------*/
/* Ce programme appartient au projet eflore, port par l'association          */
/* Tela Botanica (http://www.tela-botanica.org). Il a pour but d'tablir les  */
/* structures d'informations necessaires  l'etablissement d'une flore        */
/* electronique et de dvelopper les outils informatiques les exploitant.     */ 
/*                                                                            */
/* Copyright (C) 2001 tela-botanica. This program is free software;           */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* either version 2 of the License, or (at your option) any later version.    */
/* This program is distributed in the hope that it will be useful, but        */
/* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details. You should have received a copy of the GNU General       */
/* Public License along with this program; if not, write to the               */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    */
/*----------------------------------------------------------------------------*/

class ListeTaxonsAccess{

var $monCurseur;   /*unCurseur sur une requte SQL*/

function ListetaxonsAccess()
{
}



function readRow($row)

	/* Cette mthode permet d'affecter les donnes d'une ligne ramene par une curseur */
	/*  un object de type Nomtaxon.  */
	/* $row : la ligne contenant les donnes */
	/* Resultat: un nouvel object Nomtaxon contenant les donnes de la ligne */   

{
	$unTaxon = new NomTaxon();
	$unTaxon = NomTaxonAccess::readRow($row);
	return($unTaxon);
}

function openListeTaxonsCursorNomsValides($dblink,$db,$rangtaxomin,$rangtaxomax,$nommin,$nommax,$nomssespecemin,$nomssespecemax,$numclass,$radical)
	/* Cette mthode ouvre un curseur sur l'ensemble des noms de taxons recherchs  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* $rangtaxomin : indique le rang taxonomique minimum  ne pas dpasser        */
	/* $rangtaxomax : indique le rang taxonomique maximum  ne pas dpasser        */
	/* $nommin : indique le nom minimum  ne pas dpasser */
	/* $nommax : indique le nom maximum  ne pas dpasser */
	/* $nomssespecemin : indique le nom minimum de sous-espce  ne pas dpasser */
	/* $nomssespecemax : indique le nom maximum de sous-espce  ne pas dpasser */
	/* $numclass : le numro identifiant la classification recherche */
	/*             si <> -1 on ne rcupre que les noms valides    */
	/* $radical : indique le radical recherch */
	/* Rsultat : aucun */   

{
	$sql="select * ";
	$sql.="from ".EF_TNT." n ";
	if ($numclass!=-1 )
	{	$sql.=", ".EF_TCT." c ";}
	$sql.="where  n.".EF_TNT_NOM." >= \"$nommin\" ";
	if ($nommax!="")
	{	$sql.="and n.".EF_TNT_NOM." <= \"$nommax\" ";	}
	if ($nomssespecemin!="")
	{	$sql.="and n.".EF_TNT_NOM_SS_ESPECE." >= \"$nomssespecemin\" ";	}
	if ($nomssespecemax!="")
	{	$sql.="and n.".EF_TNT_NOM_SS_ESPECE." <= \"$nomssespecemax\" ";	}
	if ($rangtaxomin!=-1)
	{	$sql.="and n.".EF_TNT_RANG_TAXONOMIQUE." >= $rangtaxomin ";	}
	if ($rangtaxomax!=-1)
	{	$sql.="and n.".EF_TNT_RANG_TAXONOMIQUE." <= $rangtaxomax ";	}
	if ($numclass!=-1 )
	{	$sql.="and c.".EF_TCT_NUM_NOM_INF." =  n.".EF_TNT_NUM_NOMENCLATURAL." ";
		$sql.="and c.".EF_TCT_NUM_CLASS." = $numclass ";
	}
	if ($radical!="")
	{  
		$sql.="and  (n.".EF_TNT_NOM." like \"%$radical%\" ";
		$sql.="or  n.".EF_TNT_NOM_SS_ESPECE." like \"%$radical%\" ";
		$sql.="or  n.".EF_TNT_NOM_INFRA_2." like \"%$radical%\" ";
		$sql.="or  n.".EF_TNT_NOM_INFRA_3." like \"%$radical%\") ";
	}
	$sql.="order by n.".EF_TNT_NOM.", n.".EF_TNT_NOM_SS_ESPECE." ";



	$this->monCurseur=mysql($db,$sql,$dblink);

}

function openListeTaxonsCursorNomsNonValides($dblink,$db,$rangtaxomin,$rangtaxomax,$nommin,$nommax,$nomssespecemin,$nomssespecemax,$numclass,$radical)
	/* Cette mthode ouvre un curseur sur l'ensemble des noms de taxons recherchs  */
	/* Non valides pour la classification donne                                    */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* $rangtaxomin : indique le rang taxonomique minimum  ne pas dpasser        */
	/* $rangtaxomax : indique le rang taxonomique maximum  ne pas dpasser        */
	/* $nommin : indique le nom minimum  ne pas dpasser */
	/* $nommax : indique le nom maximum  ne pas dpasser */
	/* $nomssespecemin : indique le nom minimum de sous-espce  ne pas dpasser */
	/* $nomssespecemax : indique le nom maximum de sous-espce  ne pas dpasser */
	/* $numclass : le numro identifiant la classification non recherche        */
	/*             si <> -1 on ne rcupre que les noms non valides    */		
	/* $radical : indique le radical recherch */
	/* Rsultat : aucun */   

{

	$sql="select  n.".EF_TNT_NUM_TAXONOMIQUE.", ";
   	$sql.=" n.".EF_TNT_NUM_NOMENCLATURAL.", ";
   	$sql.=" n.".EF_TNT_RANG_TAXONOMIQUE.", ";
   	$sql.=" n.".EF_TNT_NOM.", ";
   	$sql.=" n.".EF_TNT_AUTEUR.", ";
   	$sql.=" n.".EF_TNT_TYPE_SS_ESPECE.", ";
   	$sql.=" n.".EF_TNT_NOM_SS_ESPECE.", ";
   	$sql.=" n.".EF_TNT_AUTEUR_SS_ESPECE.", ";
   	$sql.=" n.".EF_TNT_TYPE_INFRA_2.", ";
   	$sql.=" n.".EF_TNT_NOM_INFRA_2.", ";
   	$sql.=" n.".EF_TNT_AUTEUR_INFRA_2.", ";
   	$sql.=" n.".EF_TNT_TYPE_INFRA_3.", ";
   	$sql.=" n.".EF_TNT_NOM_INFRA_3.", ";
   	$sql.=" n.".EF_TNT_AUTEUR_INFRA_3.", ";
   	$sql.=" n.".EF_TNT_SOURCE_BIBLIO.", ";
   	$sql.=" n.".EF_TNT_ANNEE.", ";
   	$sql.=" n.".EF_TNT_SOURCE_BIBLIO_A_EXCLURE.", ";
   	$sql.=" n.".EF_TNT_INFO_COMBINAISON.", ";
   	$sql.=" n.".EF_TNT_TYPE_SYNONYMIE.", ";
   	$sql.=" n.".EF_TNT_DOUTE_NOM_VALIDE.", ";
   	$sql.=" n.".EF_TNT_HYBRIDE.", ";
   	$sql.=" n.".EF_TNT_AUTEUR_PRINCIPAL.", ";
   	$sql.=" n.".EF_TNT_IN_AUTEUR.", ";
   	$sql.=" n.".EF_TNT_STATUT.", ";
	$sql.=" c.".EF_TCT_NUM_NOM_INF." ";
	$sql.="from ".EF_TNT." n left outer join ".EF_TCT." c ";
	$sql.=" on c.".EF_TCT_NUM_NOM_INF." =  n.".EF_TNT_NUM_NOMENCLATURAL." ";
	$sql.="and c.".EF_TCT_NUM_CLASS." = $numclass "; 
	$sql.="where  n.".EF_TNT_NOM." >= \"$nommin\" ";
	if ($nommax!="")
	{	$sql.="and n.".EF_TNT_NOM." <= \"$nommax\" ";	}
	if ($nomssespecemin!="")
	{	$sql.="and n.".EF_TNT_NOM_SS_ESPECE." >= \"$nomssespecemin\" ";	}
	if ($nomssespecemax!="")
	{	$sql.="and n.".EF_TNT_NOM_SS_ESPECE." <= \"$nomssespecemax\" ";	}
	if ($rangtaxomin!=-1)
	{	$sql.="and n.".EF_TNT_RANG_TAXONOMIQUE." >= $rangtaxomin ";	}
	if ($rangtaxomax!=-1)
	{	$sql.="and n.".EF_TNT_RANG_TAXONOMIQUE." <= $rangtaxomax ";	}
	if ($radical!="")
	{  
		$sql.="and  (n.".EF_TNT_NOM." like \"%$radical%\" ";
		$sql.="or  n.".EF_TNT_NOM_SS_ESPECE." like \"%$radical%\" ";
		$sql.="or  n.".EF_TNT_NOM_INFRA_2." like \"%$radical%\" ";
		$sql.="or  n.".EF_TNT_NOM_INFRA_3." like \"%$radical%\") ";
	}
	$sql.="and c.".EF_TCT_NUM_NOM_INF." is null ";
	$sql.="order by n.".EF_TNT_NOM.", n.".EF_TNT_NOM_SS_ESPECE." ";

        /*echo $sql;*/

	$this->monCurseur=mysql($db,$sql,$dblink);

}


function openListeTaxonsCursor3($dblink,$db,$rangtaxomin,$rangtaxomax,$nommin,$nommax,$nomssespecemin,$nomssespecemax)
{
	$sql="select * ";
	$sql.="from ".EF_TNT." n ";
	$sql.="where  n.".EF_TNT_NOM." >= \"$nommin\" ";
	$sql.="and n.".EF_TNT_NOM." <= \"$nommax\" ";
	if ($nomssespecemin!="" and $nomssespecemax!="")
	{
		$sql.="and n.".EF_TNT_NOM_SS_ESPECE." >= \"$nomssespecemin\" ";
		$sql.="and n.".EF_TNT_NOM_SS_ESPECE." <= \"$nomssespecemax\" ";
	}
	$sql.="and n.".EF_TNT_RANG_TAXONOMIQUE." >= $rangtaxomin ";
	$sql.="and n.".EF_TNT_RANG_TAXONOMIQUE." <= $rangtaxomax ";
	$sql.="order by n.".EF_TNT_NOM.", n.".EF_TNT_NOM_SS_ESPECE." ";


	$this->monCurseur=mysql($db,$sql,$dblink);

}

function openListeTaxonsSynonymesCursor($numclass, $numtaxo,$dblink,$db)
	/* Cette mthode ouvre un curseur sur l'ensemble des synonymes d'un taxon  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* $numtaxo : le numerotaxonomique du taxon recherch */
	/* $numclass : le numro identifiant la classification */
	/* Rsultat : aucun */

{	
	$sql="select * ";
	$sql.="from ".EF_TNT." n, ".EF_TCT." c ";
	$sql.="where n.".EF_TNT_NUM_TAXONOMIQUE."= $numtaxo ";
	$sql.="and n.".EF_TNT_NUM_NOMENCLATURAL."<> c.".EF_TCT_NUM_NOM_INF." ";
	$sql.="and c.".EF_TCT_NUM_TAXO_INF."= $numtaxo ";
	$sql.="and c.".EF_TCT_NUM_CLASS."= $numclass ";
	
	$this->monCurseur=mysql($db,$sql,$dblink);
}

function openListeSynonymesCursor($numtaxo,$dblink,$db)
	/* Cette mthode ouvre un curseur sur l'ensemble des synonymes d'un taxon  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* $numtaxo : le numerotaxonomique du taxon recherch */
	/* Rsultat : aucun */

{	
	$sql="select * ";
	$sql.="from ".EF_TNT." n ";
	$sql.="where n.".EF_TNT_NUM_TAXONOMIQUE."= $numtaxo ";
	
	$this->monCurseur=mysql($db,$sql,$dblink);
}


function openNomsValidesCursor($numclass,$numtaxo,$dblink,$db)

	/* Cette mthode ouvre un curseur sur l'ensemble des noms valides d'un taxon relativement  une classification */
	/* $numclass : le numro identifiant la classification */
	/* $numtaxo : le numro indetifiant le taxon */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Rsultat : aucun */

{
	$sql="select * ";
	$sql.="from ".EF_TNT." n, ".EF_TCT." c ";
	$sql.="where n.".EF_TNT_NUM_TAXONOMIQUE."= $numtaxo ";
	$sql.="and n.".EF_TNT_NUM_NOMENCLATURAL."= c.".EF_TCT_NUM_NOM_INF." ";
	$sql.="and c.".EF_TCT_NUM_TAXO_INF."= $numtaxo ";
	$sql.="and c.".EF_TCT_NUM_CLASS."= $numclass ";

	$this->monCurseur=mysql($db,$sql,$dblink);
}
	


function closeListeTaxonsCursor()
	/* Cette mthode ferme le curseur  */
	/* Rsultat : aucun */  
{
	mysql_free_result($this->monCurseur);
}

function nextTaxon($dblink,$db)
	/* Cette mthode permet de lire une  une les lignes ramenes par le curseur  */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Rsultat : un object NomTaxon ou NULL quand il n'y a plus de lignes  lire */   
{
	$monTaxon;
	
	if (mysql_num_rows($this->monCurseur)>0)
	{	
		if($row = mysql_fetch_array($this->monCurseur,MYSQL_ASSOC))
		{
			$monTaxon = ListeTaxonsAccess::readRow($row);
		}
		else
		{	$monTaxon =NULL;	}					
	}
	
	return($monTaxon);
}



}
?>