<?

/*----------------------------------------------------------------------------*/
/* Ce programme appartient au projet eflore, port par l'association          */
/* Tela Botanica (http://www.tela-botanica.org). Il a pour but d'tablir les  */
/* structures d'informations necessaires  l'etablissement d'une flore        */
/* electronique et de dvelopper les outils informatiques les exploitant.     */ 
/*                                                                            */
/* Copyright (C) 2001 tela-botanica. This program is free software;           */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* either version 2 of the License, or (at your option) any later version.    */
/* This program is distributed in the hope that it will be useful, but        */
/* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details. You should have received a copy of the GNU General       */
/* Public License along with this program; if not, write to the               */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    */
/*----------------------------------------------------------------------------*/

/* class Nomtaxon : permet de stocker en mmoire les informations issues
		    de la table EFLORE_NOMS_TAXONS.
		    
*/

class NomTaxon{

var $numerotaxonomique;
var $numeroNomenclatural;
var $rangtaxonomique;
var $nom;
var $auteur;
var $typeSousEspece;
var $nomSousEspece;
var $auteurSousEspece;
var $typeInfra2;
var $nomInfra2;
var $auteurInfra2;
var $typeInfra3;
var $nomInfra3;
var $auteurInfra3;
var $sourceBiblio;
var $annee;
var $sourceBiblioAExclure;
var $infoCombinaison;
var $typeSynonymie;
var $douteNomValide;
var $hybride;
var $auteurPrincipal;
var $inAuteur;
var $statut;

function getTypeSousEspece()
{
	switch($this->typeSousEspece){
		case 1:	$res="subsp.";
			break;
		case 2:	$res="n-subsp.";
			break;
		case 3:	$res="[subsp.]";
			break;
		case 4:	$res="[n-subsp.]";
			break;
	}
	return($res);
}

function getTypeInfra2()
{
	switch($this->typeInfra2){
		case 1:	$res="var.";
			break;
		case 2:	$res="[var.]";
			break;
		case 3:	$res="n-var.";
			break;
		case 4:	$res="proles";
			break;
		case 5:	$res="[n-var.]";
			break;
	}
	return($res);
}

function getTypeInfra3()
{
	switch($this->typeInfra3){
		case 1:	$res="n-proles";
			break;
		case 2:	$res="proles";
			break;
		case 3:	$res="fa.";
			break;
		case 4:	$res="subvar.";
			break;
		case 5:	$res="convar.";
			break;
		case 6:	$res="cv.";
			break;
		case 7:	$res="n-fa";
			break;
	}
	return($res);
}

function NomTaxon()
{


}

/*
function GetNomTaxonXML()
{
	$res = "<NOM_TAXON numnom=\"".$this->numeroNomenclatural."\" rangtaxo=\"$this->rangtaxonomique\">";
	$res.= "<NOM ";
	if ($this->auteur!="") { $res.="auteur=\"".htmlentities($this->auteur)."\""; }
	$res.=">".$this->nom."</NOM>";
	if ($this->nomSousEspece!="") 
	{ $res.= "<NOM ";
	  if ($this->typeSousEspece!="") { $res.= "type=\"".htmlentities($this->getTypeSousEspece())."\""; }
	  if ($this->auteurSousEspece!="") { $res.= " auteur=\"".htmlentities($this->auteurSousEspece)."\""; }
	  $res.=">".htmlentities($this->nomSousEspece)."</NOM>"; 
	
	}
	if ($this->nomInfra2!="") 
	{ $res.= "<NOM ";
	  if ($this->typeInfra2!="") { $res.= "type=\"".htmlentities($this->getTypeInfra2())."\""; }
	  if ($this->auteurInfra2!="") { $res.= " auteur=\"".htmlentities($this->auteurInfra2)."\""; }
	  $res.=">".htmlentities($this->nomInfra2)."</NOM>"; 
	
	}
	if ($this->nomInfra3!="") 
	{ $res.= "<NOM ";
	  if ($this->typeInfra3!="") { $res.= "type=\"".htmlentities($this->getTypeInfra3())."\""; }
	  if ($this->auteurInfra3!="") { $res.= " auteur=\"".htmlentities($this->auteurInfra3)."\""; }
	  $res.=">".htmlentities($this->nomInfra3)."</NOM>"; 
	
	}
	if ($this->sourceBiblio!="") 
	{ $res.= "<BIBLIOGRAPHIE>".htmlentities(str_replace(""," ",$this->sourceBiblio))."</BIBLIOGRAPHIE>"; }
	if ($this->sourceBiblioAExclure!="") 
	{ $res.= "<BIBLIO_A_EXCLURE>".htmlentities(str_replace(""," ",$this->sourceBiblioAExclure))."</BIBLIO_A_EXCLURE>"; }
	$res.= "</NOM_TAXON>\n";
	
	return($res);	
}
*/

function GetNomTaxonXML()
{
	$res = "<NOM_TAXON numnom=\"".$this->numeroNomenclatural."\" rangtaxo=\"$this->rangtaxonomique\" ";
	if ($this->typeSynonymie!="") { $res.="tsyn=\"".$this->typeSynonymie."\""; }
	$res.=">";
	$res.= "<NOM ";
	if ($this->auteur!="") { $res.="auteur=\"".htmlspecialchars($this->auteur)."\""; }
	$res.=">".htmlspecialchars($this->nom)."</NOM>";
	if ($this->nomSousEspece!="") 
	{ $res.= "<NOM ";
	  if ($this->typeSousEspece!="") { $res.= "type=\"".htmlspecialchars($this->getTypeSousEspece())."\""; }
	  if ($this->auteurSousEspece!="") { $res.= " auteur=\"".htmlspecialchars($this->auteurSousEspece)."\""; }
	  $res.=">".htmlspecialchars($this->nomSousEspece)."</NOM>"; 
	
	}
	if ($this->nomInfra2!="") 
	{ $res.= "<NOM ";
	  if ($this->typeInfra2!="") { $res.= "type=\"".htmlspecialchars($this->getTypeInfra2())."\""; }
	  if ($this->auteurInfra2!="") { $res.= " auteur=\"".htmlspecialchars($this->auteurInfra2)."\""; }
	  $res.=">".htmlspecialchars($this->nomInfra2)."</NOM>"; 
	
	}
	if ($this->nomInfra3!="") 
	{ $res.= "<NOM ";
	  if ($this->typeInfra3!="") { $res.= "type=\"".htmlspecialchars($this->getTypeInfra3())."\""; }
	  if ($this->auteurInfra3!="") { $res.= " auteur=\"".htmlspecialchars($this->auteurInfra3)."\""; }
	  $res.=">".htmlspecialchars($this->nomInfra3)."</NOM>"; 
	
	}
	if ($this->sourceBiblio!="") 
	{ $res.= "<BIBLIOGRAPHIE";
	  if ($this->sourceBiblio!="") { $res.=" annee=\"".htmlspecialchars($this->annee)."\"";  }
	  $res.=">".htmlspecialchars(str_replace(""," ",$this->sourceBiblio))."</BIBLIOGRAPHIE>"; 
	}
	if ($this->sourceBiblioAExclure!="") 
	{ $res.= "<BIBLIO_A_EXCLURE>".htmlspecialchars(str_replace(""," ",$this->sourceBiblioAExclure))."</BIBLIO_A_EXCLURE>"; }
	
	if ($this->infoCombinaison!="") 
	{ $res.= "<INFO_COMBINAISON>".htmlspecialchars(str_replace(""," ",$this->infoCombinaison))."</INFO_COMBINAISON>"; }
	
	$res.= "</NOM_TAXON>\n";
	return($res);	
}

} //Fin classe Taxon


class NomTaxonClassif extends NomTaxon 
{
var $numeroTaxonomiqueSup;
var $numeroNomenclaturalSup;
var $numeroTaxonomiqueInf;
var $numeroNomenclaturalInf;
var $classificationGlobale;

function NomTaxonClassif()
{

}

function NomTaxonClassif($unTaxon)
{
 $this->numerotaxonomique=$unTaxon->numerotaxonomique;
 $this->numeroNomenclatural=$unTaxon->numeroNomenclatural;
 $this->rangtaxonomique=$unTaxon->rangtaxonomique;
 $this->nom=$unTaxon->nom;
 $this->auteur=$unTaxon->auteur;
 $this->typeSousEspece=$unTaxon->typeSousEspece;
 $this->nomSousEspece=$unTaxon->nomSousEspece;
 $this->auteurSousEspece=$unTaxon->auteurSousEspece;
 $this->typeInfra2=$unTaxon->typeInfra2;
 $this->nomInfra2=$unTaxon->nomInfra2;
 $this->auteurInfra2=$unTaxon->auteurInfra2;
 $this->typeInfra3=$unTaxon->typeInfra3;
 $this->nomInfra3=$unTaxon->nomInfra3;
 $this->auteurInfra3=$unTaxon->auteurInfra3;
 $this->sourceBiblio=$unTaxon->sourceBiblio;
 $this->annee=$unTaxon->annee;
 $this->sourceBiblioAExclure=$unTaxon->sourceBiblioAExclure;
 $this->infoCombinaison=$unTaxon->infoCombinaison;
 $this->typeSynonymie=$unTaxon->typeSynonymie;
 $this->douteNomValide=$unTaxon->douteNomValide;
 $this->hybride=$unTaxon->hybride;
 $this->auteurPrincipal=$unTaxon->auteurPrincipal;
 $this->inAuteur=$unTaxon->inAuteur;
 $this->statut=$unTaxon->statut;

}

}

?>