<?

/*----------------------------------------------------------------------------*/
/* Ce programme appartient au projet eflore, port par l'association          */
/* Tela Botanica (http://www.tela-botanica.org). Il a pour but d'tablir les  */
/* structures d'informations necessaires  l'etablissement d'une flore        */
/* electronique et de dvelopper les outils informatiques les exploitant.     */ 
/*                                                                            */
/* Copyright (C) 2001 tela-botanica. This program is free software;           */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* either version 2 of the License, or (at your option) any later version.    */
/* This program is distributed in the hope that it will be useful, but        */
/* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details. You should have received a copy of the GNU General       */
/* Public License along with this program; if not, write to the               */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    */
/*----------------------------------------------------------------------------*/

  /* Cette classe permet de dfinir les mthodes d'accs  la table NOMS_TAXONS */
  /* aussi bien en lecture qu'en criture */

class NomTaxonAccess{


function NomTaxonAccess()
{
}


function readRow($row)

	/* Cette mthode permet d'affecter les donnes d'une ligne ramene par une curseur */
	/*  un object de type Nomtaxon.  */
	/* $row : la ligne contenant les donnes */
	/* Resultat: un nouvel object Nomtaxon contenant les donnes de la ligne */   

{
                                              
	$unNomTaxon = new NomTaxon;
	$unNomTaxon->numerotaxonomique =$row[EF_TNT_NUM_TAXONOMIQUE];
	$unNomTaxon->numeroNomenclatural =$row[EF_TNT_NUM_NOMENCLATURAL];
	$unNomTaxon->rangtaxonomique =$row[EF_TNT_RANG_TAXONOMIQUE];
	$unNomTaxon->nom =$row[EF_TNT_NOM];
	$unNomTaxon->auteur =$row[EF_TNT_AUTEUR];
	$unNomTaxon->typeSousEspece =$row[EF_TNT_TYPE_SS_ESPECE];
	$unNomTaxon->nomSousEspece =$row[EF_TNT_NOM_SS_ESPECE];
	$unNomTaxon->auteurSousEspece =$row[EF_TNT_AUTEUR_SS_ESPECE];
	$unNomTaxon->typeInfra2 =$row[EF_TNT_TYPE_INFRA_2];
	$unNomTaxon->nomInfra2 =$row[EF_TNT_NOM_INFRA_2];
	$unNomTaxon->auteurInfra2 =$row[EF_TNT_AUTEUR_INFRA_2];
	$unNomTaxon->typeInfra3 =$row[EF_TNT_TYPE_INFRA_3];
	$unNomTaxon->nomInfra3 =$row[EF_TNT_NOM_INFRA_3];
	$unNomTaxon->auteurInfra3 =$row[EF_TNT_AUTEUR_INFRA_3];
	$unNomTaxon->sourceBiblio =$row[EF_TNT_SOURCE_BIBLIO];
	$unNomTaxon->annee =$row[EF_TNT_ANNEE];
	$unNomTaxon->sourceBiblioAExclure =$row[EF_TNT_SOURCE_BIBLIO_A_EXCLURE];
	$unNomTaxon->infoCombinaison =$row[EF_TNT_INFO_COMBINAISON];
	$unNomTaxon->typeSynonymie =$row[EF_TNT_TYPE_SYNONYMIE];
	$unNomTaxon->douteNomValide =$row[EF_TNT_DOUTE_NOM_VALIDE];
	$unNomTaxon->hybride =$row[EF_TNT_HYBRIDE];
	$unNomTaxon->auteurPrincipal =$row[EF_TNT_AUTEUR_PRINCIPAL];
	$unNomTaxon->inAuteur =$row[EF_TNT_IN_AUTEUR];
	$unNomTaxon->statut =$row[EF_TNT_STATUT];
	
	return($unNomTaxon);
	
}

function getNomTaxon($numNomenclatural,$dblink,$db)

	/* Cette mthode permet de lire dans la base le taxon ayant un certain numero nomenclatural  */
	/* $numNomenclatural : le numro nomenclatural correspodant au nom de taxon recherch        */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* Rsultat : un nouvel object Nomtaxon contenant les donnes de la ligne */   

{
	$sql="select * ";
	$sql.="from ".EF_TNT." ";
	$sql.="where ".EF_TNT_NUM_NOMENCLATURAL."= $numNomenclatural ";	


	If ($res=mysql($db,$sql,$dblink))
	{
		if (mysql_num_rows($res)==1)
		{	$row = mysql_fetch_array($res,MYSQL_ASSOC);
			$unNomTaxon = NomTaxonAccess::readRow($row);
			return $unNomTaxon;		
		}
	}
	

	

}


function getNomTaxonValide($numclass,$numtaxo,$dblink,$db,$unNomTaxon)

	/* Cette mthode permet de lire dans la base le nom valide d'un taxon relativement  une classification */
	/* $numclass : le numro identifiant la classification */
	/* $numtaxo : le numro indetifiant le taxon */
	/* $dblink : le lien sur la base de donnes */
	/* $db : le nom de la base de donnes */
	/* $unNomTaxon : rsultat de la mthode un nouvel object Nomtaxon contenant les donnes de la ligne */

{
	$sql="select * ";
	$sql.="from ".EF_TNT." n, ".EF_TCT." c ";
	$sql.="where n.".EF_TNT_NUM_TAXONOMIQUE."= $numtaxo ";
	$sql.="and n.".EF_TNT_NUM_NOMENCLATURAL."= c.".EF_TCT_NUM_NOM_INF." ";
	$sql.="and c.".EF_TCT_NUM_TAXO_INF."= $numtaxo ";
	$sql.="and c.".EF_TCT_NUM_CLASS."= $numclass ";


	If ($res=mysql($db,$sql,$dblink))
	{
		if (mysql_num_rows($res)==1)
		{	
			$row = mysql_fetch_array($res,MYSQL_ASSOC);
			$unNomTaxon = NomTaxonAccess::readRow($row);		
		}
	}
	

	

}

} //Fin classe Taxon
?>