<?
/*----------------------------------------------------------------------------*/
/* Ce programme appartient au projet eflore, port par l'association          */
/* Tela Botanica (http://www.tela-botanica.org). Il a pour but d'tablir les  */
/* structures d'informations necessaires  l'etablissement d'une flore        */
/* electronique et de dvelopper les outils informatiques les exploitant.     */ 
/*                                                                            */
/* Copyright (C) 2001 tela-botanica. This program is free software;           */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* either version 2 of the License, or (at your option) any later version.    */
/* This program is distributed in the hope that it will be useful, but        */
/* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details. You should have received a copy of the GNU General       */
/* Public License along with this program; if not, write to the               */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    */
/*----------------------------------------------------------------------------*/

/*------------------------------------------------------------*/
/* include                                                    */
/*------------------------------------------------------------*/

include('header.inc.php');
include(EF_PATH_DBACCESS."connexionefloredb.inc.php");

include(EF_PATH_DBACCESS."eflore_classifications.def.php");
include(EF_PATH_DBACCESS."eflore_noms_taxons.def.php");
include(EF_PATH_DBACCESS."eflore_classification_taxons.def.php");

include(EF_PATH_CLASSES."classification.obj.php");
include(EF_PATH_CLASSES."classificationaccess.obj.php");
include(EF_PATH_CLASSES."nomtaxon.obj.php");
include(EF_PATH_CLASSES."nomtaxonaccess.obj.php");
include(EF_PATH_CLASSES."classificationtaxonsaccess.obj.php");

/*----------------------------------------------------------------*/
/* Recherche des paramtres de la requte et criture de l'entte */
/*----------------------------------------------------------------*/
$eFlore_numclass="-1";
$eFlore_profondeur=-1;
$eFlore_numnom=-1;
$eFlore_rangtaxo=0;


$rang;
$ligne;
$level;
$oldlevel;

function count_sep($string, $sep)
{
	$pos=1;
	$pos=strpos($string,$sep,$pos);
	$res =0;
	while($pos>0)
	{
		$res=$res+1;
		$pos=strpos($string,$sep,$pos+1);
	}
	return $res;
}


function writerow($unTaxon)
{
	
	global $rang;
	global $ligne;
	global $level;
	global $oldlevel;
	
	$ligne++;
	$level=(integer)(strlen($unTaxon->classificationGlobale)/10);

	if (($level==$oldlevel[$rang])&&($ligne>1)) 
	{
		echo "</CLASSIFICATION_TAXON>\n";
	}
	if ($level>$oldlevel[$rang])
	{  
		$rang++;
		$oldlevel[$rang]=$level;
		echo "<LISTE_CLASSIFICATIONS_FILLES>\n";
	}
	if ($level<$oldlevel[$rang])
	{
		/*echo "cpt=".$oldlevel[$rang]." level ".$level."<BR>";*/
		for($cpt=$oldlevel[$rang];$cpt>$level;$cpt--)
		{  
			if ($cpt==$oldlevel[$rang]) { echo "</CLASSIFICATION_TAXON>\n"; }
			echo "</LISTE_CLASSIFICATIONS_FILLES>\n";
			echo "</CLASSIFICATION_TAXON>\n";
		}
		$rang=$level;
	}
	
	echo "<CLASSIFICATION_TAXON numtaxo=\"$unTaxon->numerotaxonomique\" >\n";
	echo $unTaxon->GetNomTaxonXML();
}

echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?>\n";


echo "<FICHE_CLASSIFICATION_TAXONS version=\"1.0\" ";
if ( isset($HTTP_GET_VARS))
{
	reset($HTTP_GET_VARS);
	foreach ($HTTP_GET_VARS as $k=>$elem)
	{
		${"eFlore_$k"}= $elem;
		echo " $k=\"$elem\""; 
	}
}
echo ">\n";


if ($eFlore_rangtaxo==0) { $eFlore_rangtaxo=100000000; }
if ($eFlore_profondeur==-1) { $eFlore_profondeur=100000000; }

/*----------------------------------------------------------------*/
/* Connection  la base de donne                                 */
/*----------------------------------------------------------------*/

$lk=connectdb();


/*----------------------------------------------------------------*/
/* Ecriture de la classification                                  */
/*----------------------------------------------------------------*/
$maClassification;

if ($eFlore_numclass=="-1")
{
	echo "<ERREUR>La classification n$eFlore_numclass n'est pas connue du serveur!</ERREUR>";
}
else
{
	$maClassification = ClassificationAccess::getClassification($eFlore_numclass,$lk,$db);
	if ($maClassification!=NULL) {	echo $maClassification->getClassificationXML();	}
	else { echo "<ERREUR>Le paramtre numclass est obligatoire!</ERREUR>"; }
}

/*----------------------------------------------------------------*/
/* Ecriture des taxons                                            */
/*----------------------------------------------------------------*/
if ($maClassification!=NULL)
{
	$classificationglobale="";
	if (($eFlore_numnom==-1)||($eFlore_numnom==$maClassification->premierTaxon->numeroNomenclatural))
	{
		echo "<CLASSIFICATION_TAXON numtaxo=\"".$maClassification->premierTaxon->numerotaxonomique."\" >\n";
		echo $maClassification->premierTaxon->GetNomTaxonXML();
		$classificationglobale=sprintf("%010d",$maClassification->premierTaxon->numeroNomenclatural);
		
	}
	else
	{	$unNomTaxonClassif;
		ClassificationTaxonsAccess::getNomTaxonClassif($eFlore_numclass,$eFlore_numnom,$lk,$db,&$unNomTaxonClassif);
		$classificationglobale=$unNomTaxonClassif->classificationGlobale;
		
	}
		

	$maClassificationTaxonsAccess = new ClassificationTaxonsAccess();
	$maClassificationTaxonsAccess->openClassificationTaxonCursor($lk,$db,$eFlore_numclass,$classificationglobale,$eFlore_rangtaxo,$eFlore_profondeur);
	
	
	
	$rang=(integer)(strlen($classificationglobale)/10);
	$ligne=0;
	$level=2;
	$oldlevel[$rang]=(integer)(strlen($classificationglobale)/10);
	
	$test=0;
	
	while(($unTaxon = $maClassificationTaxonsAccess->nextClassificationTaxon($lk,$db))&&(test<100))
	{	$test=$test+1;	
		writerow($unTaxon);
	
	}
	$maClassificationTaxonsAccess->closeClassificationTaxonCursor();
	
/*----------------------------------------------------------------*/
/* Fermeture de l'arborescence                                    */
/*----------------------------------------------------------------*/
	
	for($cpt=$oldlevel[$rang];$cpt>$oldlevel[(integer)(strlen($classificationglobale)/10)];$cpt--)
	{  
		if ($cpt==$oldlevel[$rang]) { echo "</CLASSIFICATION_TAXON>\n"; }
		echo "</LISTE_CLASSIFICATIONS_FILLES>\n";
		echo "</CLASSIFICATION_TAXON>\n";
	}
	if ($ligne==1){	echo "</CLASSIFICATION_TAXON>\n";	}




}

mysql_close();

echo "</FICHE_CLASSIFICATION_TAXONS>";

?>
