<?

/*----------------------------------------------------------------------------*/
/* Ce programme appartient au projet eflore, port par l'association          */
/* Tela Botanica (http://www.tela-botanica.org). Il a pour but d'tablir les  */
/* structures d'informations necessaires  l'etablissement d'une flore        */
/* electronique et de dvelopper les outils informatiques les exploitant.     */ 
/*                                                                            */
/* Copyright (C) 2001 tela-botanica. This program is free software;           */
/* you can redistribute it and/or modify it under the terms of the GNU        */
/* General Public License as published by the Free Software Foundation;       */
/* either version 2 of the License, or (at your option) any later version.    */
/* This program is distributed in the hope that it will be useful, but        */
/* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY */
/* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License    */
/* for more details. You should have received a copy of the GNU General       */
/* Public License along with this program; if not, write to the               */
/* Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.    */
/*----------------------------------------------------------------------------*/

/*------------------------------------------------------------*/
/* include                                                    */
/*------------------------------------------------------------*/
include('header.inc.php');

include(EF_PATH_DBACCESS."connexionefloredb.inc.php");

include(EF_PATH_DBACCESS."eflore_noms_taxons.def.php");
include(EF_PATH_DBACCESS."eflore_classification_taxons.def.php");
include(EF_PATH_DBACCESS."eflore_noms_vernaculaires_taxons.def.php");
include(EF_PATH_DBACCESS."eflore_noms_vernaculaires.def.php");

include(EF_PATH_CLASSES."nomtaxon.obj.php");
include(EF_PATH_CLASSES."nomtaxonaccess.obj.php");
include(EF_PATH_CLASSES."listetaxonsaccess.obj.php");
include(EF_PATH_CLASSES."classificationtaxonsaccess.obj.php");
include(EF_PATH_CLASSES."nomvernaculaire.obj.php");
include(EF_PATH_CLASSES."nomvernaculaireaccess.obj.php");
include(EF_PATH_CLASSES."listenomsvernaculairesaccess.obj.php");

/*----------------------------------------------------------------*/
/* Recherhce des paramtres de la requte et criture de l'entte */
/*----------------------------------------------------------------*/
$eFlore_numclass =-1;
$eFlore_numtaxo =-1;
$eFlore_numnom =-1;


echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" standalone=\"no\"?>\n";
echo "<FICHE_IDENTITES_TAXONS version=\"1.0\" ";
if ( isset($HTTP_GET_VARS))
{
	reset($HTTP_GET_VARS);
	foreach ($HTTP_GET_VARS as $k=>$elem)
	{
		${"eFlore_$k"}= $elem;
		echo " $k=\"$elem\""; 
	}
}
echo ">\n";





/*----------------------------------------------------------------*/
/* Connection  la base de donne                                 */
/*----------------------------------------------------------------*/

$lk=connectdb();

/*----------------------------------------------------------------*/
/* Chargement du numro taxonomique si interrogation par          */
/* numero nomenclatural                                           */
/*----------------------------------------------------------------*/
  if ($eFlore_numnom>=-1 && $eFlore_numtaxo==-1)
  { 
  	$unNomTaxon = NomTaxonAccess::getNomTaxon($eFlore_numnom,$lk,$db);
  	$eFlore_numtaxo= $unNomTaxon->numerotaxonomique;
  }

/*----------------------------------------------------------------*/
/* Certains noms n'ont pas de numero taxonomique, cela correspond */
/* a priori,  des donnees invalides dans la base eflore, il n'est*/
/* alors pas possible de donner des renseignements supplmentaires*/
/*----------------------------------------------------------------*/

  if ($eFlore_numtaxo==0) {
      mysql_close();
      echo "</FICHE_IDENTITES_TAXONS>";
      exit;
  }

/*----------------------------------------------------------------*/
/* Ecriture du nom valide ou des noms valides !                   */
/* en effet aprs la cration d'une classification, il se peut    */
/* qu'un mme taxon ai t classifi deux fois sous un nom        */
/* diffrent. on aura alors deux noms valides pour ce taxon dans  */
/* la classification (Evidemment d'un point de vue informatique)  */ 
/* Cela mettra donc en vidence une incohrence.                  */
/*----------------------------------------------------------------*/
	$cpt=0;
	$premiernomvalide;
	$nomsvalides="";
	$maListeTaxonsAccess = new ListeTaxonsAccess();
	$maListeTaxonsAccess->openNomsValidesCursor($eFlore_numclass,$eFlore_numtaxo,$lk,$db);


	while($unTaxon = $maListeTaxonsAccess->nextTaxon($lk,$db))
	{	 	
  		$nomsvalides .= $unTaxon->GetNomTaxonXML();
  		$cpt = $cpt +1;
  		if ($cpt==1) { $premiernomvalide = $unTaxon; }
	
	}

	$maListeTaxonsAccess->closeListeTaxonsCursor();

	if($cpt==1)
	{
		echo "<NOM_VALIDE numtaxo=\"".$eFlore_numtaxo."\">\n";
		echo $nomsvalides;
		echo "</NOM_VALIDE>\n";
	}
	if($cpt>1)
	{
		echo "<LISTE_NOMS_VALIDES numtaxo=\"".$eFlore_numtaxo."\">\n";
		echo $nomsvalides;
		echo "</LISTE_NOMS_VALIDES>\n";
	}
	$unTaxon;
	


/*----------------------------------------------------------------*/
/* Ecriture des parents dans la classification                    */
/*----------------------------------------------------------------*/
	$unParent;
	$numNom=$premiernomvalide->numeroNomenclatural;
	$numTaxo=$premiernomvalide->numerotaxonomique;
	ClassificationTaxonsAccess::getNomTaxonClassif($eFlore_numclass,$numNom,$lk,$db,&$unParent);
	$numTaxo=$unParent->numeroTaxonomiqueSup;
	$numNom=$unParent->numeroNomenclaturalSup;
	ClassificationTaxonsAccess::getNomTaxonClassif($eFlore_numclass,$numNom,$lk,$db,&$unParent);
	$res="";

	while($unParent!=null)
	{

		$resinter="<NOM_TAXON_PARENTS numtaxo=\"$unParent->numerotaxonomique\">";
		$resinter.= $unParent->GetNomTaxonXML();
		$resinter.= "</NOM_TAXON_PARENTS>\n";
		$res=$resinter.$res;
		$numTaxo=$unParent->numeroTaxonomiqueSup;
		$numNom=$unParent->numeroNomenclaturalSup;
		$unParent=null;
		ClassificationTaxonsAccess::getNomTaxonClassif($eFlore_numclass,$numNom,$lk,$db,&$unParent);

	}
	$unParent=NomTaxonAccess::getNomTaxon($numNom,$lk,$db);
	if ($unParent<>NULL)
	{
		$resinter= "<NOM_TAXON_PARENTS numtaxo=\"$unParent->numerotaxonomique\">";
		$resinter.= $unParent->GetNomTaxonXML();
		$resinter.= "</NOM_TAXON_PARENTS>\n";
		$res=$resinter.$res;
	}
	
if ($res<>"")
{
	echo "<LISTE_NOMS_TAXONS_PARENTS numtaxo=\"$eFlore_numtaxo\">\n";
	echo $res;
	echo "</LISTE_NOMS_TAXONS_PARENTS>\n";
}

/*----------------------------------------------------------------*/
/* Ecriture des synonymes                                         */
/*----------------------------------------------------------------*/

$maListeTaxonsAccess = new ListeTaxonsAccess();
$res="";

if($nomsvalides<>"")
	{ $maListeTaxonsAccess->openListeTaxonsSynonymesCursor($eFlore_numclass,$eFlore_numtaxo,$lk,$db); }
else
	{ $maListeTaxonsAccess->openListeSynonymesCursor($eFlore_numtaxo,$lk,$db);	}


while($unTaxon = $maListeTaxonsAccess->nextTaxon($lk,$db))
{	 	
  $res.= $unTaxon->GetNomTaxonXML();
	
}

$maListeTaxonsAccess->closeListeTaxonsCursor();

if ($res<>"")
{
	echo "<LISTE_SYNONYMES numtaxo=\"$eFlore_numtaxo\">\n";
	echo $res;
	echo "</LISTE_SYNONYMES>\n";;
}


/*----------------------------------------------------------------*/
/* Ecriture des noms vernaculaires                                */
/*----------------------------------------------------------------*/

$res="";
$maListeNomsVernaculairesAccess = new ListeNomsVernaculairesAccess();
$maListeNomsVernaculairesAccess->openListeNomsVernaculairesCursor($lk,$db,$eFlore_numtaxo);


while($unNomVernaculaire = $maListeNomsVernaculairesAccess->nextNomVernaculaire($lk,$db))
{	 	
  $res.= $unNomVernaculaire->GetNomVernaculaireXML();
	
}

$maListeNomsVernaculairesAccess->closeListeNomsVernaculairesCursor();

if ($res<>"")
{
	echo "<LISTE_NOMS_VERNACULAIRES numtaxo=\"$eFlore_numtaxo\">\n";
	echo $res;
	echo "</LISTE_NOMS_VERNACULAIRES>\n";
}


mysql_close();

echo "</FICHE_IDENTITES_TAXONS>";

?>
